<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolPodlaStavu;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use InvalidArgumentException;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaStavu;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\DataTableRowContract;

/**
 * Class PocetKontrolPodlaStavuDataTableRow
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolPodlaStavu
 */
final class PocetKontrolPodlaStavuDataTableRow implements DataTableRowContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum
     */
    private StavEmisnejKontrolyEnum $stavEmisnejKontroly;

    /**
     * @var int
     */
    private int $spolu = 0;

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum $stavEmisnejKontroly
     */
    public function __construct(StavEmisnejKontrolyEnum $stavEmisnejKontroly)
    {
        $this->stavEmisnejKontroly = $stavEmisnejKontroly;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaStavu $pocetKontrolPodlaStavu
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaStavu $pocetKontrolPodlaStavu): self
    {
        if (false === $this->stavEmisnejKontroly->equals($pocetKontrolPodlaStavu->stav())) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa stav emisnej kontroly %s, vstupny atribut obsahuje stav emisnej kontroly %s',
                $this->stavEmisnejKontroly->value,
                $pocetKontrolPodlaStavu->stav()->value
            ));
        }

        $this->spolu += $pocetKontrolPodlaStavu->pocet();

        return $this;
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum
     */
    public function stav(): StavEmisnejKontrolyEnum
    {
        return $this->stavEmisnejKontroly;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'label' => ucfirst($this->stavEmisnejKontroly->label),
            'data' => [
                'spolu' => $this->spolu,
            ],
        ];
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
